#include <stdio.h>
#include <stdlib.h>
#include <asm/ioctl.h> 
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/mman.h>
#include "amcc.h"

/*-- Ioctls ----------------------------------------------------------*/

#define AB_IOCTL_BASE		0x00
#define AB_FIFO_IOCTL_BASE	0x40
#define AB_MB_IOCTL_BASE	0x80
#define AB_PT_IOCTL_BASE	0xC0

/* general (from 0x00) */

#define ABIORESET		_IO('z', (AB_IOCTL_BASE + 0))
#define ABIORESETADDON		_IO('z', (AB_IOCTL_BASE + 1))
#define ABIOSETLATENCY		_IOW('z', (AB_IOCTL_BASE + 2), u_char)
#define ABIOSTART		_IOW('z', (AB_IOCTL_BASE + 3), u_int)
#define ABIOSTOP		_IO('z', (AB_IOCTL_BASE + 4))
#define ABIOCONFIGURE		_IOW('z', (AB_IOCTL_BASE + 5), u_int)
#define ABIOGMCSR		_IOR('z', (AB_IOCTL_BASE + 6), u_int)
#define ABIOGINTCSR		_IOR('z', (AB_IOCTL_BASE + 7), u_int)
#define ABIOGINFOADDR		_IOR('z', (AB_IOCTL_BASE + 8), u_int)
#define ABIOGMWTC		_IOR('z', (AB_IOCTL_BASE + 9), u_int)
#define ABIOGMRTC		_IOR('z', (AB_IOCTL_BASE + 10), u_int)
#define ABIOGCOUNTER		_IOR('z', (AB_IOCTL_BASE + 11), u_int)
#define ABIOGCPUTIME		_IOR('z', (AB_IOCTL_BASE + 12), u_int)
#define ABIOGBUFFERSIZE		_IOR('z', (AB_IOCTL_BASE + 13), u_int)
#define ABIOGA2PBUFFER		_IOR('z', (AB_IOCTL_BASE + 14), u_int)
#define ABIOGP2ABUFFER		_IOR('z', (AB_IOCTL_BASE + 15), u_int)

static void printIOCTL() {
  printf("ABIORESET:\t%x\n",ABIORESET);
  printf("ABIORESETADDON:\t%x\n",ABIORESETADDON);
  printf("ABIOSETLATENCY:\t%x\n",ABIOSETLATENCY);
  printf("ABIOSTART:\t%x\n",ABIOSTART);
  printf("ABIOSTOP:\t%x\n",ABIOSTOP);
  printf("ABIOCONFIGURE:\t%x\n",ABIOCONFIGURE);
  printf("ABIOGMCSR:\t%x\n",ABIOGMCSR);
  printf("ABIOGINTCSR:\t%x\n",ABIOGINTCSR);
  printf("ABIOGINFOADDR:\t%x\n",ABIOGINFOADDR);
  printf("ABIOGMWTC:\t%x\n",ABIOGMWTC);
  printf("ABIOGMRTC:\t%x\n",ABIOGMRTC);
  printf("ABIOGCOUNTER:\t%x\n",ABIOGCOUNTER);
  printf("ABIOGCPUTIME:\t%x\n",ABIOGCPUTIME);
  printf("ABIOGBUFFERSIZE:%x\n",ABIOGBUFFERSIZE);
  printf("ABIOGA2PBUFFER:\t%x\n",ABIOGA2PBUFFER);
  printf("ABIOGP2ABUFFER:\t%x\n",ABIOGP2ABUFFER);
}

void readInfoBuffer(unsigned long addr) {
  int memfd, i;
  unsigned char *info_buffer;
  unsigned long *info_buffer_l;
  memfd = open("/dev/mem", O_RDWR);
  info_buffer = (unsigned char *)mmap(0,0x1000, PROT_READ|PROT_WRITE, 
    MAP_SHARED, memfd, addr);
  info_buffer_l = (unsigned long *)info_buffer;

  for(i=0;i<10;i++) {
    printf("%10lx",info_buffer_l[i]);
  }
  printf("\n");
  munmap(info_buffer, 0x1000);
  close(memfd);
}

int main(int argc, char argv[][]) {
  int ret, fd;
  unsigned int temp;
  unsigned long long test=1<<31;

/*
  _mcsr mcsr;
  printf("Hello World.\n");
  mcsr.reg = 0x101010;
  printf("%x\n",mcsr.reg); 
  printf("%x\n",mcsr._t._status);
  printf("%x\n",mcsr.status);
*/
  printIOCTL();
  fd = open("/dev/ab0",O_RDWR);
  ret = ioctl(fd, ABIOGBUFFERSIZE, &temp);
  printf("bufferSize: %lx %lx\n", temp, temp<<10); 
  ret = ioctl(fd, ABIOGINFOADDR, &temp);
  printf("INFOADDR: %lx\n", temp); 
  ret = ioctl(fd, ABIOGA2PBUFFER, &temp);
  printf("A2PBUFFER: %lx\n", temp); 
  ret = ioctl(fd, ABIOGP2ABUFFER, &temp);
  printf("P2ABUFFER: %lx\n", temp); 
  ret = ioctl(fd, ABIOGCPUTIME, &test);
  printf("CPUTIME: %16Lx\n", test); 
  ret = ioctl(fd, ABIOGINFOADDR, &temp);
  readInfoBuffer(temp);
  //printIOCTL();
  
  close(fd);
  printf("%d\n",sizeof(unsigned long long));

  return 0;
}
