/* version to talk to amcc using io ports */
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>    
#include <sys/io.h> /* for io ports and iopl() */
#include <asm/io.h> /* for io ports and iopl() */
#include "amcc.h"

#define AMCC 10e8
#define BOARD 4750
int main(int argc, char **argv) {
  char msg[255];
  int ret, pcidata[5],i;
  FILE *fp;
  unsigned long bar0,ioaddr;
  unsigned long intcsr, mcsr, mrar, mrtc;
  
  ret=iopl(3); /* grant us access to all the io ports */
  if(ret)
  {
  	printf("Unable to gain access to I/O ports\n");
	return(-1);
  }

  ret = system("rm /tmp/pci.dat");
  ret = system("grep 10e84750 /proc/bus/pci/devices > /tmp/pci.dat");
  /* printf("ret: %d\n",ret); */
  fp = fopen("/tmp/pci.dat","r");
  for (i=0;i<4;i++) {
    fscanf(fp,"%x",pcidata+i);
    //printf("%x\n",*(pcidata+i));
  }
  fclose(fp);

  bar0 = pcidata[3];  /* AMCC Registers */
  printf("bar0: %x\n",bar0);

  if(!(bar0 & 1)) /*if bar0 ends with 0 - memory mapped */
  {
  	printf("This version is for I/O mapped devices\n");
	return(-1);
  }
  /* else its I/O mapped */
	
  printf("Preparing for I/O mapped device\n");
  ioaddr = bar0 & 0xfffc;  /* lose the I/O and reserved bits */
  printf("ioaddr: %x\n",ioaddr);

/* you might want to read both /usr/doc/HOWTO/mini/IO-Port-Programming
   and /usr/include/asm/io.h there are other ways to do this */
     
  intcsr = inl(ioaddr + AMCC_OP_REG_INTCSR); 
  mcsr = inl(ioaddr + AMCC_OP_REG_MCSR);   
  mrar = inl(ioaddr  + AMCC_OP_REG_MRAR);
  mrtc = inl(ioaddr + AMCC_OP_REG_MRTC);

  printf ("intcsr: %lx\n",intcsr); 
  printf ("mcsr: %lx\n",mcsr); 
  printf ("mrar: %lx\n",mrar); 
  printf ("mrtc: %lx\n",mrtc); 
  
}
