/* version to talk to amcc using io ports */
/* you might want to read both /usr/doc/HOWTO/mini/IO-Port-Programming
   and /usr/include/asm/io.h there are other ways to do this */
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>    
#include <time.h>
#include <math.h>                                                               
#include <signal.h>
#include <sys/io.h> /* for io ports and iopl() */
#include <asm/io.h> /* for io ports and iopl() */
#include "amcc.h"

#define AMCC 10e8
#define BOARD 4750

void print_registers(unsigned long ioaddr);
int getMemconfig();
void get_register(unsigned long ioaddr, unsigned long *target);
void set_register(unsigned long ioaddr, unsigned long target);
void get_pci_info(unsigned long *pcidata);
int writehtonl(int fd, unsigned long *src, unsigned int length);
void disp_mcsr(unsigned int mcsr);
     
void get_pci_info(unsigned long *pcidata) {
  int ret, i;
  FILE *fp;

  ret = system("rm /tmp/pci.dat");
  ret = system("grep 10e84750 /proc/bus/pci/devices > /tmp/pci.dat");
  /* printf("ret: %d\n",ret); */
  fp = fopen("/tmp/pci.dat","r");
  for (i=0;i<4;i++) {
    fscanf(fp,"%x",pcidata+i);
    //printf("%x\n",*(pcidata+i));
  }
  fclose(fp);
}

void print_registers(unsigned long ioaddr) {
  unsigned long intcsr, mcsr, mrar, mrtc, mwar, mwtc;
/*
  intcsr = inl(ioaddr + AMCC_OP_REG_INTCSR); 
  mcsr = inl(ioaddr + AMCC_OP_REG_MCSR);   
  mrar = inl(ioaddr  + AMCC_OP_REG_MRAR);
  mrtc = inl(ioaddr + AMCC_OP_REG_MRTC);
  mwar = inl(ioaddr  + AMCC_OP_REG_MWAR);
  mwtc = inl(ioaddr + AMCC_OP_REG_MWTC);
*/
  get_register(ioaddr + AMCC_OP_REG_INTCSR, &intcsr);
  get_register(ioaddr + AMCC_OP_REG_MCSR, &mcsr);
  get_register(ioaddr + AMCC_OP_REG_MRAR, &mrar);
  get_register(ioaddr + AMCC_OP_REG_MRTC, &mrtc);
  get_register(ioaddr + AMCC_OP_REG_MWAR, &mwar);
  get_register(ioaddr + AMCC_OP_REG_MWTC, &mwtc);

  printf ("  intcsr: %4x\t",intcsr); 
  printf ("mrar: %8x\t",mrar); 
  printf ("mrtc: %3x\t",mrtc); 
  printf ("mwar: %8x\t",mwar); 
  printf ("mwtc: %8x\t",mwtc); 
  printf ("mcsr: %4x\n",mcsr); 
  disp_mcsr(mcsr);
} 

void get_register(unsigned long ioaddr, unsigned long *target) {
  int i;
  char *temp;
  /*
  temp = (char *) target;
  for (i=0;i<4;i++) {
    temp[i] = inb(ioaddr+i);
  }
  */
  *target = inl(ioaddr);
} 

void set_register(unsigned long ioaddr, unsigned long target) {
  int i;
  unsigned char *temp, temp2;
  /*
  printf("Setting: %lx :",ioaddr);
  temp = (char *) (&target);
  for (i=0;i<4;i++) {
    temp2 = temp[i];
    printf(" %x",temp2);
    outb(ioaddr+i,temp2); // wrong order!!!!
  }
  printf("\n");
  */
  //printf("Setting: %lx: %lx",ioaddr, target);
  //temp2 = getchar();
  //printf("\n");
  outl(target, ioaddr);  // stupid parameter list order  content,addr
}

int getMemconfig() {
  FILE *fp;
  char msg[255], *ptr, temp[3];
  int mem;
 
  fp = fopen("/proc/cmdline","rb");
  fgets(msg,255,fp);
  fclose(fp);
  ptr = (char *) strstr(msg,"mem");
  sscanf(ptr,"%3s=%d",temp,&mem);
 
  return mem;
}               

int writehtonl(int fd, unsigned long *src, unsigned int length) {
  // length is number of *BYTES*
  int len, i, ret=0;
  short *tmp_s, eor;
  long data, *tmp;
  len = length>>2;
  for (i=0;i<len;i++) {
    data = htonl(src[i]);
    ret = write(fd,&data,4);
  }
}            

void disp_mcsr(unsigned int mcsr) {
  char msg[8][80] = {"PCI to Add-On FIFO FULL", 
                  "PCI to Add-On FIFO 4+ spaces",
                  "PCI to Add-On FIFO Empty",
                  "Add-On to PCI FIFO Full",
                  "Add-On to PCI 4+ words",
                  "Add-On to PCI FIFO Empty",
                  "PCI to Add-On TCR equals 0",
                  "Add-on to PCI TCR equals 0"};
  int i;

  for (i=0;i<8;i++) {
    if (mcsr & (1<<(7-i)) ) printf("\t%d: %s\n",7-i,msg[7-i]);
  }
}

