#include<stdlib.h>
#include<stdio.h>
#include <linux/pci.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>    

#include "lowio.h"
#include "board_rw.h"

#define NATINST_VENDOR_ID 0x1093
#define PCI_DIO_32HS_ID 0x1150
//#define BAR0  0xfafff000
//#define BAR1  0xfaffe000

unsigned char *mite, *card;
int fd;
unsigned long Board_Base_Address, MITE_Base_Address;     /* the BAR0 address is Mite_Base_Address*/                             
unsigned int INPUTBUFFER1, STATUSBUFFER, MITE_LINK_ADDR;

int getBAR(unsigned int vendor, unsigned int board, unsigned int *bar);
int getMemconfig();
 
uint8 Setup_Mite(void)
{
  struct pci_dev *dev = NULL;
  unsigned long addr=0;
  int i;
  unsigned long *lmite, mite_addr;
  unsigned int BAR[5], BAR0, BAR1;
  int ret;
  int mem;
/*
  dev = pci_find_device(NATINST_VENDOR_ID,PCI_DIO_32HS_ID,dev);
  if (dev==NULL) printf("No card!\n");
*/
  mem = getMemconfig();
  INPUTBUFFER1 = (mem+1) << 20;
  MITE_LINK_ADDR = (mem+0) << 20;
  STATUSBUFFER = INPUTBUFFER1 - 0x1000;
  
  ret = getBAR(NATINST_VENDOR_ID, PCI_DIO_32HS_ID, BAR);
  if (ret<0) {
    perror("No Card!\n");
    return -1;
  } 
  BAR0 = BAR[3];
  BAR1 = BAR[4];
 
  addr = ( (0xffffff00 & BAR1) | 0x80 );

  fd = open("/dev/mem",O_RDWR);

  if (fd<0) { perror ("opening /dev/mem "); return 1;}

  mite = (unsigned char *) mmap(0, 4096, PROT_READ|PROT_WRITE, 
    MAP_SHARED, fd, BAR0);
  if (!mite) { perror("mapping mite "); return 1;}  
  MITE_Base_Address = (unsigned long)mite;
  card = (unsigned char *) mmap(0, 4096, PROT_READ|PROT_WRITE, 
    MAP_SHARED, fd, BAR1);
  Board_Base_Address = (unsigned long) card;
  if (!card) { perror("mapping card "); return 1;}  
  lmite =(unsigned long *) (mite+0x340);
  write32(mite+0x340, 0xaeae);
/* 
  Copy the card address into the mite register space
  You must write all 4 bytes at once!
  memcpy does not work.
*/
/*
  lmite = (unsigned long *)(mite+0xc0);
  *lmite = addr;
*/
//  *(unsigned long *)(mite+0xc0)=addr;
  write32_offset(mite, 0xc0, addr);

  printf("\n");
  for(i=24;i<28;i++) {
    printf("i: %d\t char: %c\t ascii: %d\n", i, card[i], card[i]);
  }

  return 0;
}

void close_mite(void ) {
  printf("closing mite...\n");
  munmap(mite,4096);
  munmap(card,4096);
  close(fd);
}

int getBAR(unsigned int vendor, unsigned int board, unsigned int *bar) {
  char msg[255];
  int ret, i;
  FILE *fp;
  
  sprintf(msg, "grep %x%x /proc/bus/pci/devices > /tmp/pci.dat",vendor, board);
  ret = system(msg);
  fp = fopen("/tmp/pci.dat","r");
  for (i=0;i<5;i++){
    ret = fscanf(fp, "%x",bar+i);
  }
  return ret;
}

int getMemconfig() {
  FILE *fp;
  char msg[255], *ptr, temp[3];
  int mem;

  fp = fopen("/proc/cmdline","rb");
  fgets(msg,255,fp);
  fclose(fp);
  ptr = (char *) strstr(msg,"mem");
  sscanf(ptr,"%3s=%d",temp,&mem);
  
  return mem;
}
 
